#!BPY
""" Registration info for Blender menus
Name: 'ph_SetGlobalVal_V1_5'
Blender: 231
Group: 'Misc'
"""
########################################################
#
#  Script ph_SetGlobalVal_V1_5.py
#
#  Cree le 09/12/2003.
#
#  #### USAGE ###################################
#  #
#  # Demmarer le script (ALT P ou File-Run),
#  #
#  # Ensuite selectionnez vos vertex en mode edit
#  # et retourner en mode 'Objet'.
#  #
#  # Vous pouvez maintenant attribuer des valeurs globale
#  # a votre selection de vertices.
#  #
#  # Ce script vous permettra aussi de realigner vos
#  # vertices selectionnes sur un des points (au choix)
#  # de votre selection.
#  #
#  # Je pense qu'apres quelques essais, vous aurez vite
#  # compris comment fonctionne le script.
#  #
#  # PS(1):
#  # Votre selection est purge a chaque appui
#  # sur le bouton "Apply", si le bouton "Free select"
#  # est enfonce.
#  # SI vous laissez le bouton "Free select" en position haute,
#  # cela vous permettra de faire plusieurs ralignements a la suite.
#  #
#  # PS(2):
#  # Python ne supprime pas vraiment les objets,
#  # c'est pourquoi apres utilisation du script
#  # vous risquez de voir dans la fenetre "OOPS"
#  # des objets nommes "dust..." (si vous avez active le bouton
#  # "Scene data").
#  # Pas de panique (ces objets peuvent etre en nombres considerable),
#  # pour purger la fenetre il vous suffit de faire une sauvegarde
#  # et puis 'Reopen last', et la oh miracle, tout devient 'clean' !!!
#  #
#  ##########################
#
#
#  N'hesitez pas a m'envoyer vos commentaires, suggestions, si le coeur
#  vous en dit.
#
#  coolphil@worldonline.fr
#  
####################################

import Blender
from Blender import *
from Blender.Draw import *
from Blender.BGL import *

######################

calque = 1

SelectVertices = []

LocVerticesCo = []
GloVerticesCo = []
InitGloVerticesCo = []
InitLocVerticesCo = []
PrintedIndex = []

warn = 0
warn2 = 0
ecran = 0

ApplyToX = 0
ApplyToY = 0
ApplyToZ = 0

ToggleSel = Create(0)
Offset = Create(0)
AxeX = Create(0)
AxeY = Create(0)
AxeZ = Create(0)
SlidGlobVal = Create(0.000)
lstep=Create(10.000)
PointAxeX = Create(1)
PointAxeY = Create(0)
PointAxeZ = Create(0)
SlidFromPoint = Create(0)


BL_VERSION = Blender.Get('version')
if (BL_VERSION<=223):
    import Blender210
  
#############################################################
# SUBS from LOCAL to GLOBAL coordinates                     #
#############################################################

def GlobalPosition(P, Obj):
    #
    # Prend les coordonnees locale d'un point (Vertice from Mesh)
    # Et les transforme en coordonnees global
    #
    if (BL_VERSION<=223):
        m = Obj.matrix
    else:
        m = Obj.getMatrix()

    try:    ############################## Version officielle ############################################

        PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
        PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
        PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
        return [PX, PY, PZ]

    except: ############################## Version TUHOPUU ############################################

        PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
        PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
        PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
        return [PX, PY, PZ]

def LocalPosition(P, Obj):
    #
    # Prend les coordonnees global d'un point
    # Et les transforme en coordonnees locale  (Vertice from Mesh)
    #
    if (BL_VERSION<=223):
        m = Blender210.getObject(Obj.name).inverseMatrix
    else:
        m = Obj.getInverseMatrix()

    try:    ############################## Version officielle ############################################

        PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
        PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
        PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
        return [PX, PY, PZ]

    except: ############################## Version TUHOPUU ############################################

        PX = P[0]*m[0] + P[1]*m[4] + P[2]*m[8] + m[12]
        PY = P[0]*m[1] + P[1]*m[5] + P[2]*m[9] + m[13]
        PZ = P[0]*m[2] + P[1]*m[6] + P[2]*m[10] + m[14]
        return [PX, PY, PZ]

######################

###############
def info_Obj():
###############
	global calque

	Ob = []
	Obtype = 0
	mename = []
	me = []
	calque = 1

	if Object.GetSelected():
		Ob = Object.GetSelected()[0]
		if (Ob.getType() == 'Mesh'):
			print "Object mesh"
			Obtype = 1
			calque = Ob.Layer                    # Le "layer" de l'object selectionne
			mename = Ob.getData().name
			me = Ob.getData()

	return Ob,Obtype,mename,me

######################
###################################
def PrintIndex(sel,globco,obj,me):#
###################################
    global calque

    listobj = []
    scene = Scene.GetCurrent()

    count = 0
    for ind in sel:

        tpob = Object.New('Armature')
        tpob.setName(str(ind))
        tpob.LocX = globco[count][0]
        tpob.LocY = globco[count][1]
        tpob.LocZ = globco[count][2]
        tpob.Layer = calque
        tpob.setDrawMode(8)

        scene.link(tpob)

        listobj.append(tpob)


        count += 1

    scene.update(0)
    Blender.Window.RedrawAll()

    return listobj

######################
###########################
def DeleteObj(ListObject):#
###########################

  Curscene = Scene.GetCurrent()
  Curscenename = Curscene.name
#  print Curscenename

  checknewscene = 0

  allscenes = Scene.Get()
  for f in allscenes:
      if f.name == 'dust-bin':
          checknewscene = 1

  if checknewscene == 0:
      newscene = Scene.New('dust-bin')     # create a new scene
  else:
      newscene = Scene.Get('dust-bin')


  objets = Object.GetSelected()
  if ListObject != []:
      for f in ListObject:
          Curscene.unlink(f)               # Unlink object to scene
          newscene.link(f)                 # link object to scene
          temp = f.name
          f.setName("dust"+temp)

      Curscene.makeCurrent()               # make this the current scene



  Scene.Unlink(newscene)

  Curscene.update(1)
  Blender.Window.RedrawAll()

##########################
def getSelectedVerts(me):#
##########################

	theSelVerts = []
	for v in me.verts:
		if v.sel:
			theSelVerts.append(v.index)

	return theSelVerts

###########################################
###########################################
def InitialCoFromSelIndx(sel,meshObj,Obj):#
                                          #
###########################################
    LocVertsCo = []
    GloVertsCo = []
    TempGlob = []
    compt = 0
    for f in sel:
        LocVertsCo.append(meshObj.verts[f].co)
        TempGlob = GlobalPosition( LocVertsCo[compt], Obj)
        GloVertsCo.append(TempGlob)
        compt+=1
    return LocVertsCo, GloVertsCo

######################
######################
def ToggleSelected():#
                     #
######################
    global ToggleSel, SelectVertices, object, meshname, mesh

    if ToggleSel.val == 1:
        for v in SelectVertices:
            mesh.verts[v].sel = 0
        mesh.update()
        object.makeDisplayList()

    return 0

######################
######################
def Go():            #
                     #
######################
        global LenPointsSel, InitLocVerticesCo, InitGloVerticesCo, object, mesh
        global SelectVertices, GloVerticesCo, meshname, warn2, ToggleSel


#      try:

        SelectVertices = getSelectedVerts(mesh)
#        print "SelectVertices=",SelectVertices



######################################################################################################
        if SelectVertices:


          ## Recuperation des Coordonnees locale et global des points de la selection ###########

          LocVerticesCo, GloVerticesCo = InitialCoFromSelIndx(SelectVertices,mesh,object)


          InitLocVerticesCo = LocVerticesCo
          InitGloVerticesCo = GloVerticesCo


          ## Nombre de points selectionnes ##############
          LenPointsSel = len(SelectVertices)
          print LenPointsSel, " point(s) selectionne(s)."
          ###############################################

          #### Coordonnees globale pour un seule vertice ####
          #GloVertCo = GlobalPosition(LocVerticesCo[0], object)

          #### utiliser GloVertCo[0] pour coord X, etc... #####
          #print "coordonnees globale point1 : ",GloVertCo    #



          ToggleSel.val = 0

          return 1

######################################################################################################

        else:
            print "ATTENTION vous n'avez aucun vertex de selectionnes!"

            warn2 = 1

            return 0

#      except:
#        return 0



######################
######################
def MainProg(x,y,z): #
                     #
######################
        global LocVerticesCo, InitLocVerticesCo, InitGloVerticesCo, SlidFromPoint, object, mesh
        global SlidGlobVal, SelectVertices
        global PointAxeX, PointAxeY, PointAxeZ, Offset
        tempVar=[]
        TGloVerticesCo=[]

        if SlidFromPoint.val > 0:
            NewValue = InitGloVerticesCo[SlidFromPoint.val-1][0+(PointAxeY.val == 1) + 2*(PointAxeZ.val == 1)]

            for n in range(0,len(GloVerticesCo)):
                offsX = InitGloVerticesCo[n][0] + NewValue
                offsY = InitGloVerticesCo[n][1] + NewValue
                offsZ = InitGloVerticesCo[n][2] + NewValue

                TGloVerticesCo = (InitGloVerticesCo[n][0] * (x == 0) + (NewValue * (x == 1)*(Offset.val == 0)) + ( offsX * (x == 1)*(Offset.val == 1)),InitGloVerticesCo[n][1] * (y == 0) + (NewValue * (y == 1) * (Offset.val == 0)) + ( offsY * (y == 1)*(Offset.val == 1)),InitGloVerticesCo[n][2] * (z == 0) + (NewValue * (z == 1) * (Offset.val == 0)) + ( offsZ * (z == 1)*(Offset.val == 1)))

                tempVar.append(TGloVerticesCo)
                locX, locY, locZ = LocalPosition(tempVar[n], object)

                mesh.verts[SelectVertices[n]].co[0] = locX

                mesh.verts[SelectVertices[n]].co[1] = locY

                mesh.verts[SelectVertices[n]].co[2] = locZ

            NMesh.PutRaw(mesh,mesh.name)
            object.makeDisplayList()

        elif SlidFromPoint.val == 0:
            NewValue = SlidGlobVal.val

            for n in range(0,len(GloVerticesCo)):
                offsX = InitGloVerticesCo[n][0] + NewValue
                offsY = InitGloVerticesCo[n][1] + NewValue
                offsZ = InitGloVerticesCo[n][2] + NewValue

                TGloVerticesCo = (InitGloVerticesCo[n][0] * (x == 0) + (NewValue * (x == 1)*(Offset.val == 0)) + ( offsX * (x == 1)*(Offset.val == 1)),InitGloVerticesCo[n][1] * (y == 0) + (NewValue * (y == 1) * (Offset.val == 0)) + ( offsY * (y == 1)*(Offset.val == 1)),InitGloVerticesCo[n][2] * (z == 0) + (NewValue * (z == 1) * (Offset.val == 0)) + ( offsZ * (z == 1)*(Offset.val == 1)))

                tempVar.append(TGloVerticesCo)
                locX, locY, locZ = LocalPosition(tempVar[n], object)

                mesh.verts[SelectVertices[n]].co[0] = locX

                mesh.verts[SelectVertices[n]].co[1] = locY

                mesh.verts[SelectVertices[n]].co[2] = locZ

            NMesh.PutRaw(mesh,mesh.name)
            object.makeDisplayList()



######################
######################
def draw():          #
                     #
######################
  global ecran, AxeX, AxeY, AxeZ, SlidFromPoint, warn, warn2
  global SlidGlobVal, lstep, PointAxeX, PointAxeY, PointAxeZ, ToggleSel
  global LenPointsSel, GloVerticesCo, SelectVertices, Offset

  color1 = (0.99, 0.99, 0.65)
  color2 = (0.567, 0.476, 0.365)
  color2Clear = (0.567, 0.476, 0.365, 1)
  color3 = (1.0, 1.0, 0.79)
  color4 = (0.265, 0.41, 0.4)
  color4Clear = (0.265, 0.41, 0.4, 1)
  color5 = (0.4, 0.472, 0.472)
  color6 = (0.5, 0.25, 0.25)
  color7 = (0.265, 0.4, 0.3)
  colorblack = (0.0, 0.0, 0.0)
  colorwhite = (1.0, 1.0, 1.0)
  colorred = (1.0, 0.0, 0.0)
  colorcyan = (0.0, 1.0, 1.0)
  colorgrey1 = (0.8, 0.8, 0.8)


  apply(glClearColor, color4Clear)

  glClear(GL_COLOR_BUFFER_BIT)

  apply(glColor3f, colorblack)
  glRecti(1, 1, 305, 285)
  apply(glColor3f, colorgrey1)
  glRecti(1, 1, 304, 286)
  apply(glColor3f, color7)
  glRecti(1, 1, 304, 285)




  apply(glColor3f, colorblack)
  glRecti(1, 280, 210, 252)
  apply(glColor3f, colorgrey1)
  glRecti(1, 281, 209, 254)
  apply(glColor3f, color6)
  glRecti(1, 280, 209, 253)


  apply(glColor3f, colorwhite)
  glRasterPos2f(10, 262)
  Text("ph_SetGlobalVal_V1_5.py")



                ######### ecran 0 ###################################
  if ecran == 0:

    apply(glColor3f,color3)
    glRasterPos2f(10, 226)
    Text("_________________")
    glRasterPos2f(10, 228)
    Text("Ce script vous sert a :")
    glRasterPos2f(10, 208)
    Text("1 :")
    glRasterPos2f(10, 191)
    Text("- Deplacer ou attribuer des valeurs globale")
    glRasterPos2f(10, 174)
    Text("   a votre selection de points.")
    glRasterPos2f(10, 153)
    Text("2 :")
    glRasterPos2f(10, 136)
    Text("- Realigner votre selection de points")
    glRasterPos2f(10, 119)
    Text("   sur un des points de cette meme selection.")


    if warn == 1:
        apply(glColor3f, colorgrey1)
        glRecti(64, 79, 198, 103)
        apply(glColor3f, colorblack)
        glRecti(65, 78, 198, 102)
        apply(glColor3f,(1.0, 0.0, 0.0))
        glRecti(65, 79, 197, 102)

        apply(glColor3f, color3)
        glRasterPos2f(70, 88)
        Text("Need a Mesh object !")

        warn = 0

    if warn2 == 1:
        apply(glColor3f, colorgrey1)
        glRecti(64, 79, 198, 103)
        apply(glColor3f, colorblack)
        glRecti(65, 78, 198, 102)
        apply(glColor3f,(1.0, 0.0, 0.0))
        glRecti(65, 79, 197, 102)

        apply(glColor3f, color3)
        glRasterPos2f(68, 88)
        Text("Make a selection first !")

        warn2 = 0



    Button("Go!", 2, 10, 45, 40, 59, "Start the main script")
    Button("Exit", 1, 10, 10, 40, 25, "Quit !")

                ######### ecran 1 ###################################
  elif ecran == 1:

    Button("Apply", 8, 10, 10, 40, 25)

    ToggleSel = Toggle("Free select.",9,130,10,80,25,ToggleSel.val,"Free or not selected vertices.")

    apply(glColor3f,color3)
    glRasterPos2f(50, 197)
    Text("From Point #")

    SlidFromPoint = Number('', 4,130,190,80,24,SlidFromPoint.val,0,LenPointsSel)

    Offset = Toggle("Offset",4,164,45,46,78,Offset.val,"Use Offset displacement, or not.")


    apply(glColor3f,color3)
    glRasterPos2f(48, 139)
    Text("Global Value")

##################################
    if SlidFromPoint.val > 0:    #
        apply(glColor3f,color3)
        glRasterPos2f(57, 226)
        Text("Point index")

        apply(glColor3f, colorgrey1)
        glRecti(130, 219, 210, 242)
        apply(glColor3f, color5)
        glRecti(132, 221, 208, 240)

        apply(glColor3f, colorcyan)
        glRasterPos2f(133, 226)
        Text(str(SelectVertices[SlidFromPoint.val-1]))

        apply(glColor3f,color3)
        glRasterPos2f(23, 168)
        Text("From Point's Axis")

        PointAxeX = Toggle("X",5,130,160,24,24,PointAxeX.val,"Get Value 'X' from Point#...")
        PointAxeY = Toggle("Y",6,158,160,24,24,PointAxeY.val,"Get Value 'Y' from Point#...")
        PointAxeZ = Toggle("Z",7,185,160,24,24,PointAxeZ.val,"Get Value 'Z' from Point#...")


        ######### Affiche coord. globale du point# sur l'Axe choisi #########
        apply(glColor3f, colorgrey1)
        glRecti(130, 130, 210, 153)
        apply(glColor3f, color3)
        glRecti(132, 132, 208, 151)

        apply(glColor3f, colorblack)
        glRasterPos2f(133, 137)

        if PointAxeX.val == 1:
            Text(str(round(InitGloVerticesCo[SlidFromPoint.val-1][0],3)))

        if PointAxeY.val == 1:
            Text(str(round(InitGloVerticesCo[SlidFromPoint.val-1][1],3)))

        if PointAxeZ.val == 1:
            Text(str(round(InitGloVerticesCo[SlidFromPoint.val-1][2],3)))

##################################
    elif SlidFromPoint.val == 0: #
        lstep=Number('limit ', 4,220,134, 80, 17,lstep.val,1.0,1000.0)
        SlidGlobVal = Number('', 4,130,130,80,24,SlidGlobVal.val,-lstep.val,lstep.val)


    #################################
    glColor3f(1.0, 0.0, 0.0)
    glRasterPos2f(75, 107)
    Text("Apply to")###### Apply to X ######

    glColor3f(0.0, 1.0, 0.0)
    glRasterPos2f(75, 80)
    Text("Apply to")###### Apply to Y ######

    glColor3f(0.4, 0.75, 1.0)
    glRasterPos2f(75, 53)
    Text("Apply to")###### Apply to Z ######

    AxeX = Toggle("X",4,130,99,24,24,AxeX.val,"Apply Global Value to X")
    AxeY = Toggle("Y",4,130,72,24,24,AxeY.val,"Apply Global Value to Y")
    AxeZ = Toggle("Z",4,130,45,24,24,AxeZ.val,"Apply Global Value to Z")


######################
######################
def event(evt, val): #
                     #
######################
    if ( evt == ESCKEY and not val):
        object,objectype,meshname,mesh = info_Obj()
        DeleteObj(PrintedIndex)
        Exit()
    if (evt== QKEY and not val):
        object,objectype,meshname,mesh = info_Obj()
        DeleteObj(PrintedIndex)
        Exit()



######################
######################
def bevent(evt):     #
                     #
######################
    global ecran, PointAxeX, PointAxeY, PointAxeZ
    global ApplyToX, ApplyToY, ApplyToZ, mesh, InitGloVerticesCo
    global SelectVertices, object,objectype, meshname, mesh, PrintedIndex
    global AxeX, AxeY, AxeZ, SlidFromPoint, Offset, SlidGlobVal, warn, warn2
    global ToggleSel


    if   (evt== 1):
        Exit()

    elif (evt== 2):
#      try:
        object,objectype,meshname,mesh = info_Obj()

        if objectype:
          print
          print "object = ",object
          checkGo = Go()
          if checkGo:
            print "Vous avez une selection"
            ecran = 1
            PrintedIndex = PrintIndex(SelectVertices,InitGloVerticesCo,object,mesh)

        else:
            warn = 1
            ecran = 0
#      except:
#        warn = 1
#        ecran = 0

        Blender.Window.Redraw()

    elif (evt== 3):
        object,objectype,meshname,mesh = info_Obj()
        print "object = ",object

        if (object):
            warn = 1
            ecran = 0
        Blender.Window.Redraw()

    elif (evt== 4):

        MainProg(AxeX.val,AxeY.val,AxeZ.val)

        Blender.Window.Redraw()

    elif (evt== 5):
        if PointAxeX.val == 0:
            PointAxeX.val = 1
        elif PointAxeX.val == 1:
            PointAxeY.val = 0
            PointAxeZ.val = 0
        MainProg(AxeX.val,AxeY.val,AxeZ.val)
        Blender.Window.Redraw()

    elif (evt== 6):
        if PointAxeY.val == 0:
            PointAxeY.val = 1
        elif PointAxeY.val == 1:
            PointAxeX.val = 0
            PointAxeZ.val = 0
        MainProg(AxeX.val,AxeY.val,AxeZ.val)
        Blender.Window.Redraw()

    elif (evt== 7):
        if PointAxeZ.val == 0:
            PointAxeZ.val = 1
        elif PointAxeZ.val == 1:
            PointAxeX.val = 0
            PointAxeY.val = 0
        MainProg(AxeX.val,AxeY.val,AxeZ.val)
        Blender.Window.Redraw()

    elif (evt== 8):
        DeleteObj(PrintedIndex)
        ToggleSelected()
        ecran = 0

        #### Reinitialisation ####
        AxeX.val = 0
        AxeY.val = 0
        AxeZ.val = 0
        SlidFromPoint.val = 0
        PointAxeX.val = 1
        PointAxeY.val = 0
        PointAxeZ.val = 0
        Offset.val = 0
        SlidGlobVal.val = 0.000

        Blender.Window.Redraw()


    elif warn == 1:
        warn = 0

    elif warn2 == 1:
        warn2 = 0

#    print "Ecran =",ecran

######################

Register(draw, event, bevent)
######################